CREATE OR REPLACE FUNCTION SPLIT
(
       P_LIST VARCHAR2,
			 P_DEL  VARCHAR2 := ','
)
RETURN SPLIT_TBL PIPELINED

IS
       I_IDX     PLS_INTEGER;
			 I_LIST    VARCHAR2(32767) := P_LIST;
			 L_VALUE   VARCHAR2(32767);
			 
BEGIN
       LOOP
			           I_IDX := INSTR( I_LIST, P_DEL );
								 
								 IF I_IDX > 0 THEN
								    PIPE ROW( SUBSTR( I_LIST, 1, I_IDX-1 ) );
										I_LIST := SUBSTR( I_LIST, I_IDX + LENGTH( P_DEL ) );
								 ELSE
								    PIPE ROW( I_LIST );
										EXIT;
								 END IF;
			 
			 END LOOP;
			
       RETURN;
END SPLIT;
/

